# $Revision: 1.160.2.15 $, $Date: 2007/03/21 10:52:32 $
# TODO:
# - handle locales differently (runtime, since it's possible to do)
# - see ftp://ftp.debian.org/debian/pool/main/m/mozilla-firefox/*diff*
#   for hints how to make locales
# - make it more pld-like (bookmarks, default page etc..)
#
# Conditional build:
%bcond_with	tests	# enable tests (whatever they check)
%bcond_without	gnome	# disable all GNOME components (gnomevfs, gnome, gnomeui)
#
Summary:	Firefox Community Edition web browser
Summary(pl):	Firefox Community Edition - przegldarka WWW
Name:		mozilla-firefox
Version:	2.0.0.3
Release:	1
License:	MPL/LGPL
Group:		X11/Applications/Networking
Source0:	ftp://ftp.mozilla.org/pub/mozilla.org/firefox/releases/%{version}/source/firefox-%{version}-source.tar.bz2
# Source0-md5:	24398e3d98673a2a92a01a8f771ca12a
Source1:	%{name}.desktop
Source2:	%{name}.sh
Patch0:		mozilla-install.patch
Patch1:		%{name}-lib_path.patch
Patch3:		%{name}-nopangoxft.patch
Patch5:		%{name}-fonts.patch
Patch6:		%{name}-myspell.patch
Patch7:		%{name}-agent.patch
# if ac rebuild is needed...
#PatchX:	%{name}-ac.patch
URL:		http://www.mozilla.org/projects/firefox/
%{?with_gnome:BuildRequires:	GConf2-devel >= 1.2.1}
BuildRequires:	XFree86-devel
BuildRequires:	automake
BuildRequires:	cairo-devel >= 1.0.0
%{?with_gnome:BuildRequires:	gnome-vfs2-devel >= 2.0}
BuildRequires:	gtk+2-devel >= 1:2.0.0
BuildRequires:	heimdal-devel >= 0.7.1
BuildRequires:	libIDL-devel >= 0.8.0
%{?with_gnome:BuildRequires:	libgnome-devel >= 2.0}
%{?with_gnome:BuildRequires:	libgnomeui-devel >= 2.2.0}
BuildRequires:	libjpeg-devel >= 6b
BuildRequires:	libpng-devel >= 1.2.7
BuildRequires:	libstdc++-devel
BuildRequires:	myspell-devel
BuildRequires:	nspr-devel >= 1:4.6.3
BuildRequires:	nss-devel >= 1:3.11.3-3
BuildRequires:	pango-devel >= 1:1.6.0
BuildRequires:	perl-modules >= 5.004
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.356
BuildRequires:	zip
BuildRequires:	zlib-devel >= 1.2.3
Requires(post):	mktemp >= 1.5-18
Requires:	%{name}-lang-resources = %{version}
Requires:	%{name}-libs = %{epoch}:%{version}-%{release}
Requires:	browser-plugins >= 2.0
Requires:	nspr >= 1:4.6.3
Requires:	nss >= 1:3.11.3
Provides:	wwwbrowser
Obsoletes:	mozilla-firebird
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# mozilla and firefox provide their own versions
%define		_noautoreqdep		libgkgfx.so libgtkembedmoz.so libgtkxtbin.so libjsj.so libmozjs.so libxpcom.so libxpcom_compat.so libxpcom_core.so
%define		_noautoprovfiles	%{_libdir}/%{name}/components

%define		specflags	-fno-strict-aliasing

%description
Firefox Community Edition is an open-source web browser, designed for
standards compliance, performance and portability.

%description -l pl
Firefox Community Edition jest open sourcow przegldark sieci WWW,
stworzon z myl o zgodnoci ze standardami, wydajnoci i
przenonoci.

%package libs
Summary:	Firefox Community Edition shared libraries
Summary(pl):	Biblioteki wspdzielone przegldarki Firefox Community Edition
Group:		Libraries
Conflicts:	mozilla-firefox < 2.0-1.4

%description libs
Firefox Community Edition shared libraries.

%description libs -l pl
Biblioteki wspdzielone przegldarki Firefox Community Edition.

%package lang-en
Summary:	English resources for Firefox Community Edition
Summary(pl):	Anglojzyczne zasoby dla przegldarki Firefox Community Edition
Group:		X11/Applications/Networking
Requires:	%{name} = %{version}-%{release}
Provides:	%{name}-lang-resources = %{version}-%{release}

%description lang-en
English resources for Firefox Community Edition.

%description lang-en -l pl
Anglojzyczne zasoby dla przegldarki Firefox Community Edition.

%prep
%setup -qc
cd mozilla
%patch0 -p1
%patch1 -p1
%patch3 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1

sed -i 's/\(-lgss\)\(\W\)/\1disable\2/' configure

# use system
#rm -rf mozilla/nsprpub mozilla/security/nss

%build
cd mozilla
export CFLAGS="%{rpmcflags} $(%{_bindir}/pkg-config mozilla-nspr --cflags-only-I)"
export CXXFLAGS="%{rpmcflags} $(%{_bindir}/pkg-config mozilla-nspr --cflags-only-I)"

cp -f %{_datadir}/automake/config.* build/autoconf
cp -f %{_datadir}/automake/config.* nsprpub/build/autoconf
cp -f %{_datadir}/automake/config.* directory/c-sdk/config/autoconf

cat << 'EOF' > .mozconfig
. $topsrcdir/browser/config/mozconfig

# Options for 'configure' (same as command-line options).
ac_add_options --prefix=%{_prefix}
ac_add_options --exec-prefix=%{_exec_prefix}
ac_add_options --bindir=%{_bindir}
ac_add_options --sbindir=%{_sbindir}
ac_add_options --sysconfdir=%{_sysconfdir}
ac_add_options --datadir=%{_datadir}
ac_add_options --includedir=%{_includedir}
ac_add_options --libdir=%{_libdir}
ac_add_options --libexecdir=%{_libexecdir}
ac_add_options --localstatedir=%{_localstatedir}
ac_add_options --sharedstatedir=%{_sharedstatedir}
ac_add_options --mandir=%{_mandir}
ac_add_options --infodir=%{_infodir}
%if %{?debug:1}0
ac_add_options --disable-optimize
ac_add_options --enable-debug
ac_add_options --enable-debug-modules
ac_add_options --enable-debugger-info-modules
ac_add_options --enable-crash-on-assert
%else
ac_add_options --disable-debug
ac_add_options --disable-logging
ac_add_options --enable-optimize="%{rpmcflags}"
%endif
%if %{with tests}
ac_add_options --enable-tests
%else
ac_add_options --disable-tests
%endif
%if %{with gnome}
ac_add_options --enable-gnomevfs
ac_add_options --enable-gnomeui
%else
ac_add_options --disable-gnomevfs
ac_add_options --disable-gnomeui
%endif
ac_add_options --disable-freetype2
ac_add_options --disable-installer
ac_add_options --disable-javaxpcom
ac_add_options --disable-updater
ac_add_options --enable-default-toolkit=gtk2
ac_add_options --enable-svg
ac_add_options --enable-system-cairo
ac_add_options --enable-system-myspell
ac_add_options --enable-xft
ac_add_options --with-distribution-id=org.pld-linux
ac_add_options --with-system-nspr
ac_add_options --with-system-nss
ac_add_options --with-system-zlib
ac_add_options --with-system-jpeg
ac_add_options --with-system-png
ac_add_options --with-default-mozilla-five-home=%{_libdir}/%{name}
ac_cv_visibility_pragma=no
EOF

%{__make} -j1 -f client.mk build \
	CC="%{__cc}" \
	CXX="%{__cxx}"

%install
rm -rf $RPM_BUILD_ROOT
cd mozilla
install -d \
	$RPM_BUILD_ROOT{%{_bindir},%{_sbindir},%{_libdir}} \
	$RPM_BUILD_ROOT{%{_pixmapsdir},%{_desktopdir}} \
	$RPM_BUILD_ROOT%{_datadir}/%{name}

%browser_plugins_add_browser %{name} -p %{_libdir}/%{name}/plugins

%{__make} -C xpinstall/packager stage-package \
	DESTDIR=$RPM_BUILD_ROOT \
	MOZ_PKG_APPDIR=%{_libdir}/%{name} \
	PKG_SKIP_STRIP=1

# move arch independant ones to datadir
mv $RPM_BUILD_ROOT%{_libdir}/%{name}/chrome $RPM_BUILD_ROOT%{_datadir}/%{name}/chrome
mv $RPM_BUILD_ROOT%{_libdir}/%{name}/defaults $RPM_BUILD_ROOT%{_datadir}/%{name}/defaults
mv $RPM_BUILD_ROOT%{_libdir}/%{name}/extensions $RPM_BUILD_ROOT%{_datadir}/%{name}/extensions
mv $RPM_BUILD_ROOT%{_libdir}/%{name}/greprefs $RPM_BUILD_ROOT%{_datadir}/%{name}/greprefs
mv $RPM_BUILD_ROOT%{_libdir}/%{name}/icons $RPM_BUILD_ROOT%{_datadir}/%{name}/icons
mv $RPM_BUILD_ROOT%{_libdir}/%{name}/init.d $RPM_BUILD_ROOT%{_datadir}/%{name}/init.d
mv $RPM_BUILD_ROOT%{_libdir}/%{name}/res $RPM_BUILD_ROOT%{_datadir}/%{name}/res
mv $RPM_BUILD_ROOT%{_libdir}/%{name}/searchplugins $RPM_BUILD_ROOT%{_datadir}/%{name}/searchplugins
ln -s ../../share/%{name}/chrome $RPM_BUILD_ROOT%{_libdir}/%{name}/chrome
ln -s ../../share/%{name}/defaults $RPM_BUILD_ROOT%{_libdir}/%{name}/defaults
ln -s ../../share/%{name}/extensions $RPM_BUILD_ROOT%{_libdir}/%{name}/extensions
ln -s ../../share/%{name}/greprefs $RPM_BUILD_ROOT%{_libdir}/%{name}/greprefs
ln -s ../../share/%{name}/icons $RPM_BUILD_ROOT%{_libdir}/%{name}/icons
ln -s ../../share/%{name}/init.d $RPM_BUILD_ROOT%{_libdir}/%{name}/init.d
ln -s ../../share/%{name}/res $RPM_BUILD_ROOT%{_libdir}/%{name}/res
ln -s ../../share/%{name}/searchplugins $RPM_BUILD_ROOT%{_libdir}/%{name}/searchplugins

rm -rf $RPM_BUILD_ROOT%{_libdir}/%{name}/dictionaries
ln -s %{_datadir}/myspell $RPM_BUILD_ROOT%{_libdir}/%{name}/dictionaries

sed 's,@LIBDIR@,%{_libdir},' %{SOURCE2} > $RPM_BUILD_ROOT%{_bindir}/mozilla-firefox
ln -s mozilla-firefox $RPM_BUILD_ROOT%{_bindir}/firefox

install browser/base/branding/icon64.png $RPM_BUILD_ROOT%{_pixmapsdir}/mozilla-firefox.png

install %{SOURCE1} $RPM_BUILD_ROOT%{_desktopdir}/%{name}.desktop

# header/development files
rm $RPM_BUILD_ROOT%{_libdir}/%{name}/xpidl
rm $RPM_BUILD_ROOT%{_libdir}/%{name}/xpt_dump
rm $RPM_BUILD_ROOT%{_libdir}/%{name}/xpt_link

# files created by regxpcom and firefox -register
touch $RPM_BUILD_ROOT%{_libdir}/%{name}/components/compreg.dat
touch $RPM_BUILD_ROOT%{_libdir}/%{name}/components/xpti.dat

# what's this? it's content is invalid anyway.
rm -f $RPM_BUILD_ROOT%{_libdir}/%{name}/dependentlibs.list

cat << 'EOF' > $RPM_BUILD_ROOT%{_sbindir}/%{name}-chrome+xpcom-generate
#!/bin/sh
umask 022
rm -f %{_libdir}/%{name}/components/{compreg,xpti}.dat

# it attempts to touch files in $HOME/.mozilla
# beware if you run this with sudo!!!
export HOME=$(mktemp -d)
# also TMPDIR could be pointing to sudo user's homedir
unset TMPDIR TMP || :

LD_LIBRARY_PATH=%{_libdir}/%{name}${LD_LIBRARY_PATH:+:$LD_LIBRARY_PATH} %{_libdir}/%{name}/regxpcom
%{_libdir}/%{name}/firefox -register

rm -rf $HOME
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%pre
if [ -d %{_libdir}/%{name}/dictionaries ] && [ ! -L %{_libdir}/%{name}/dictionaries ]; then
	mv -v %{_libdir}/%{name}/dictionaries{,.rpmsave}
fi
for d in chrome defaults extensions greprefs icons init.d res searchplugins; do
	if [ -d %{_libdir}/%{name}/$d ] && [ ! -L %{_libdir}/%{name}/$d ]; then
		install -d %{_datadir}/%{name}
		mv %{_libdir}/%{name}/$d %{_datadir}/%{name}/$d
	fi
done
exit 0

%post
%{_sbindir}/%{name}-chrome+xpcom-generate
%update_browser_plugins

%postun
if [ "$1" = 0 ]; then
	%update_browser_plugins
fi

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/%{name}
%attr(755,root,root) %{_bindir}/firefox
%attr(755,root,root) %{_sbindir}/%{name}-chrome+xpcom-generate

# browser plugins v2
%{_browserpluginsconfdir}/browsers.d/%{name}.*
%config(noreplace) %verify(not md5 mtime size) %{_browserpluginsconfdir}/blacklist.d/%{name}.*.blacklist

%dir %{_libdir}/%{name}/components
%attr(755,root,root) %{_libdir}/%{name}/components/*.so
%{_libdir}/%{name}/components/*.js
%{_libdir}/%{name}/components/*.xpt
%dir %{_libdir}/%{name}/plugins
%attr(755,root,root) %{_libdir}/%{name}/plugins/*.so
%attr(755,root,root) %{_libdir}/%{name}/*.sh
%attr(755,root,root) %{_libdir}/%{name}/m*
%attr(755,root,root) %{_libdir}/%{name}/f*
%attr(755,root,root) %{_libdir}/%{name}/regxpcom
%attr(755,root,root) %{_libdir}/%{name}/xpcshell
%attr(755,root,root) %{_libdir}/%{name}/xpicleanup
%{_pixmapsdir}/mozilla-firefox.png
%{_desktopdir}/mozilla-firefox.desktop

# symlinks
%{_libdir}/%{name}/chrome
%{_libdir}/%{name}/defaults
%{_libdir}/%{name}/dictionaries
%{_libdir}/%{name}/extensions
%{_libdir}/%{name}/greprefs
%{_libdir}/%{name}/icons
%{_libdir}/%{name}/init.d
%{_libdir}/%{name}/res
%{_libdir}/%{name}/searchplugins

# browserconfig
%{_libdir}/%{name}/browserconfig.properties

%{_libdir}/%{name}/LICENSE
%{_libdir}/%{name}/README.txt

%dir %{_datadir}/%{name}
%{_datadir}/%{name}/chrome
%{_datadir}/%{name}/defaults
%{_datadir}/%{name}/greprefs
%{_datadir}/%{name}/icons
%{_datadir}/%{name}/init.d
%{_datadir}/%{name}/res
%{_datadir}/%{name}/searchplugins

%dir %{_datadir}/%{name}/extensions
# -dom-inspector subpackage?
%{_datadir}/%{name}/extensions/inspector@mozilla.org
# the signature of the default theme
%{_datadir}/%{name}/extensions/{972ce4c6-7e08-4474-a285-3208198ce6fd}

# files created by regxpcom and firefox -register
%ghost %{_libdir}/%{name}/components/compreg.dat
%ghost %{_libdir}/%{name}/components/xpti.dat

%files libs
%defattr(644,root,root,755)
%dir %{_libdir}/%{name}
%attr(755,root,root) %{_libdir}/%{name}/*.so

%files lang-en
%defattr(644,root,root,755)
%{_datadir}/%{name}/chrome/en-US.jar
%{_datadir}/%{name}/chrome/en-US.manifest

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: mozilla-firefox.spec,v $
Revision 1.160.2.15  2007/03/21 10:52:32  mguevara
- 2.0.0.3-1, fixes security issue MFSA 2007-11 - FTP PASV port-scanning

Revision 1.160.2.14  2007/03/13 20:29:11  spider
- more marketing user agent

Revision 1.160.2.13  2007/03/04 22:59:34  glen
- dictionaries todo is done

Revision 1.160.2.12  2007/03/04 21:10:58  glen
- fix dictionaries packaging

Revision 1.160.2.11  2007/03/04 20:26:20  glen
- use system myspell; rel 2

Revision 1.160.2.10  2007/02/25 01:51:11  glen
- revert utf8

Revision 1.160.2.9  2007/02/25 01:28:02  glen
- 2.0.0.2

Revision 1.160.2.8  2007/02/06 21:56:17  glen
- firefox script fix by jezik; rel 4

Revision 1.160.2.7  2007/01/29 23:38:05  glen
- browser plugins v2; rel 3

Revision 1.160.2.6  2007/01/27 11:33:14  hawk
- s/Mozilla Firefox/Firefox Community Edition/, "Mozilla Firefox"
  is a registered trademark and we can't use that name

Revision 1.160.2.5  2007/01/25 13:12:05  glen
- merge from HEAD
  - drop -devel, use xulrunner-devel instead
  - move arch independant files to datadir
  - now creating noarch dictionaries, languages and extensions possible
  - use rel 2 to denote the version for deps

Revision 1.160.2.4  2007/01/25 08:56:47  jasw
- enable svg support - rel 2
- STBR pls

Revision 1.160.2.3  2006/12/22 15:29:34  glen
- HEAD merge; rel 1

Revision 1.160.2.2  2006/12/22 14:20:36  prism
- updated to 2.0.0.1, builds'n'works for me.
  (fixes CVE-2006-6497 CVE-2006-6498 CVE-2006-6499 CVE-2006-6500 CVE-2006-6501
  CVE-2006-6502 CVE-2006-6503 CVE-2006-6504 CVE-2006-6506 CVE-2006-6507)

Revision 1.160.2.1  2006/12/06 00:09:08  glen
- AC-branch

Revision 1.160  2006/12/05 12:32:49  glen
- copy from DEVEL

Revision 1.95.2.62  2006/11/26 11:34:43  glen
- -libs split

Revision 1.95.2.61  2006/11/22 18:40:58  patrys
- no icon branding

Revision 1.95.2.60  2006/11/22 18:17:04  glen
- remove unfinished libs check

Revision 1.95.2.59  2006/11/22 18:04:44  glen
- package extensions/{972ce4c6-7e08-4474-a285-3208198ce6fd} otherwise the
  default theme won't show up in the selector. thx patrys.

Revision 1.95.2.58  2006/11/22 13:01:06  patrys
- builds and works as expected on x86 and x86_64
- rel 1
- please stop adding configure options if you have no idea what they do

Revision 1.95.2.57  2006/11/22 08:47:05  patrys
- patch4 is illegal if official branding is off

Revision 1.95.2.56  2006/11/21 23:10:15  patrys
- further cuts of unneeded options
- same bug remains

Revision 1.95.2.55  2006/11/21 17:49:19  patrys
- further cuts in configure (removed defaults and experimental stuff)
- still opens an extra window for each tab

Revision 1.95.2.54  2006/11/18 15:34:26  glen
- add libxpcom_core.so to _noautoreqdep

Revision 1.95.2.53  2006/11/18 15:24:31  glen
- todo update

Revision 1.95.2.52  2006/11/18 14:47:56  glen
- unpackaged files todo

Revision 1.95.2.51  2006/11/17 12:35:32  glen
- (from mozilla-lightning): don't enable elf-dynstr-gc, it's x86-only (and automatically enabled there)

Revision 1.95.2.50  2006/11/17 02:14:54  patrys
- rel up, drop BR: jdk

Revision 1.95.2.49  2006/11/17 01:10:45  patrys
- the first version not to die with "memory segmentation fault"
- java breaks things
- native-uconv causes no encodings to be supported

Revision 1.95.2.48  2006/11/12 14:45:24  glen
- todo cleanup

Revision 1.95.2.47  2006/11/12 14:41:58  glen
- -searchplugins.patch seems for < 2.0

Revision 1.95.2.46  2006/11/04 23:31:19  glen
- chrome.rdf and overlayinfo/*/*/*.rdf don't exist

Revision 1.95.2.45  2006/11/03 14:14:59  glen
- cleanups; package devel files just once

Revision 1.95.2.44  2006/11/03 13:46:20  glen
- remove --disable-v1-string-abi, it was cause of memory faults
- cleanups in spec and chrome+xpcom-generate
- package dictionaries dir
- remove {cf2812dc-6a7c-4402-b639-4d277dac4c36} extension (not built)

Revision 1.95.2.43  2006/11/03 13:00:13  glen
- javaxpcom bcond

Revision 1.95.2.42  2006/11/02 21:31:53  glen
- avoid searching for provides from internal components

Revision 1.95.2.41  2006/11/02 19:50:49  patrys
- do not touch the extensions, all mozilla products have a preset list of extensions

Revision 1.95.2.40  2006/11/02 14:59:40  qboosh
- note that ac patch is ready

Revision 1.95.2.39  2006/11/02 14:31:10  glen
- R: nss-devel for -devel

Revision 1.95.2.38  2006/11/02 14:23:14  glen
- use nss-devel that provides nss-config, drop nss patches

Revision 1.95.2.37  2006/11/02 13:48:29  qboosh
- require nspr >= 4.6.3 (as in sources)

Revision 1.95.2.36  2006/11/01 09:25:05  glen
- package all files!

Revision 1.95.2.35  2006/11/01 09:22:01  glen
- package some files

Revision 1.95.2.34  2006/11/01 09:18:18  glen
- seems javaxpcom needs jsd
- try dropping probably obsolete hacks

Revision 1.95.2.33  2006/11/01 00:48:20  glen
- added more configure options, reviewed them
- install section cleanup and skip tgz step
- firefox-chrome+xpcom-generate cleanup and comments
- postun dropped (should be done as ghost files instead)

Revision 1.95.2.32  2006/10/26 09:26:09  arekm
- 0.2

Revision 1.95.2.31  2006/10/24 23:51:55  glen
- 2.0 tarball

Revision 1.95.2.30  2006/10/02 13:54:29  glen
- disable strip from building, we do that anyway in rpm

Revision 1.95.2.29  2006/10/01 22:02:23  czarny
- a lot of TODO
- further tweaked .mozconfig
- found out which config options break later functioning
- libnssckbi.so hack (nasty - needs fixing)
- build, runns, looks like mozilla FF - probabely is a mozilla FF
- needs some twaeking and ready for PLD!

Revision 1.95.2.28  2006/10/01 16:49:51  glen
- typo

Revision 1.95.2.27  2006/10/01 14:06:24  czarny
- merged from HEAD
- up to 2.0rc1
- added config options
- reverted not appliable nss patches
- forced sysnss via .mozconfig
- tweaked .mozconfig generation
- reverted official mozilla build (we can't do that!)
- updated name.patch
- overall fixes
- added TODO
- NFY
